#include "vec.h"
#include "stdlib.h"

struct Vec {
  void ** vec_mem;
  size_t vec_len;
  size_t vec_cap;
};

/* TODO: check for NULL pointers throughout! */

Vec* vec_new() {
  Vec* r = malloc(sizeof(Vec));
  r->vec_len = 0;
  r->vec_cap = 1;
  r->vec_mem = malloc (sizeof (void *));
  // *(r->vec_mem) = NULL;		/* initialize 1st elem - not needed - see vec_free() */
  return r;
}

void vec_free(Vec* xs) {
  for (int i=0; i<xs->vec_len; i++) {
    free(*(xs->vec_mem + i));	/* free vec element */
  }
  free (xs->vec_mem);		/* free vector mem */
  free (xs);
}

void** vec_at (Vec* xs, size_t i) {
  if (i >= xs->vec_len) {
    return NULL;		/* out of range */
  }
  return (xs->vec_mem + i);
}

bool vec_push (Vec* xs, void* x) {
  if (xs->vec_len >= xs->vec_cap) {
    // really: vec_len == vec_cap
    // allocate space for next element!
    xs->vec_cap *= 2;
    xs->vec_mem = realloc (xs->vec_mem, xs->vec_cap * sizeof (void *));
  }
  // now we've got sufficient space
  *(xs->vec_mem + xs->vec_len) = x;
  xs->vec_len++;
  return true;
}

size_t vec_length (Vec* xs) {
  return xs->vec_len;
}

void vec_remove(Vec* xs, size_t i) {
  if (i < xs->vec_len) {
    // valid index
    for (size_t j = i; j < xs->vec_len - 1; j++) {
      xs->vec_mem[ j ] = xs->vec_mem[ j+1 ];
    }
    xs->vec_len--;
  }
}
